找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1238|回复: 0

使用 acedInvoke 调用 LISP函数

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2021-1-16 21:11:37 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
Calling Lisp function using acedInvoke

问题:

I am using acedInvoke to call a Lisp function but I get a return value that equals RTERROR (5001). What am I missing ?

解答:

The Lisp function must be defined as a command as shown here :

  1. ;;; (defun DoIt() Define the Lisp function as a command using c:

  2. (defun c:DoIt()

  3.   (setq pntA (getpoint "\nPick A")

  4.         pntB (getpoint pntA "\nPick B")

  5.   )

  6.   (grdraw pntA pntB 1 2)

  7. )



Here is the sample code to call the Lisp command using acedInvoke :
  1. <DllImport("acad.exe", CallingConvention:=CallingConvention.Cdecl, EntryPoint:="acedInvoke")> _

  2. Private Shared Function acedInvoke(ByVal args As IntPtr, ByRef result As IntPtr) As Integer

  3. End Function



  4. . . .



  5. Dim m_args As New Autodesk.AutoCAD.DatabaseServices.ResultBuffer()



  6. 'Returns RTERROR (5001)

  7. 'm_args.Add(New Autodesk.AutoCAD.DatabaseServices.TypedValue(5005, "DoIt"))



  8. 'Returns RTNORM (5100)

  9. m_args.Add(New Autodesk.AutoCAD.DatabaseServices.TypedValue(5005, "c:DoIt"))



  10. Dim m_ResultBuf As IntPtr = IntPtr.Zero

  11. Dim m_Return As Integer = acedInvoke(m_args.UnmanagedObject, m_ResultBuf)



  12. m_args.Dispose()

  13. MsgBox(String.Format("Return value {0}", m_Return))


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-4-23 18:37 , Processed in 0.284895 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表